UnDeadGroupMod = {}
UnDeadGroupMod.defaults = {}
UnDeadGroupMod.defaults.filtered = {}


UnDeadGroupMod.defaults.Friend1 = "" --Saved User 1
UnDeadGroupMod.defaults.Friend1Zone = ""
UnDeadGroupMod.defaults.Friend2 = "" --Saved User 2
UnDeadGroupMod.defaults.Friend2Zone = ""
UnDeadGroupMod.defaults.Friend3 = "" --Saved User 3
UnDeadGroupMod.defaults.Friend3Zone = ""
UnDeadGroupMod.FriendList = {}
UnDeadGroupMod.defaults.willAcceptLFGCheck = false
UnDeadGroupMod.defaults.willAcceptGroupInvite = false
UnDeadGroupMod.defaults.willNotAcceptTravelToLeader = false
UnDeadGroupMod.defaults.ActivityIdList = {}
UnDeadGroupMod.defaults.ActivitySetIdNames = {}
UnDeadGroupMod.defaults.ActivityIdNames = {}
UnDeadGroupMod.defaults.ActivitySetIdList = {}
UnDeadGroupMod.defaults.SelectedQName = "Random Normal Dungeon"
UnDeadGroupMod.defaults.selectedQ = 62
UnDeadGroupMod.defaults.canLeaveLFG = false
UnDeadGroupMod.MailTopic = ""
UnDeadGroupMod.MailBody = ""
UnDeadGroupMod.defaults.isDifficultyVisible = true
UnDeadGroupMod.defaults.isTitleVisible = true
UnDeadGroupMod.defaults.isRoleVisible = true
UnDeadGroupMod.defaults.isReadyCheckVisible = true
UnDeadGroupMod.defaults.didVoteNewName = false



UnDeadGroupMod.FriendToJoin = ""


local LAM = LibAddonMenu2
local groupMemberJoinedFlag = false

-- Variables
UnDeadGroupMod.name = "UnDeadGroupMod"
UnDeadGroupMod.updateTimeInSeconds = 2000

FRIEND_NOT_FRIEND = 0
FRIEND_ONLINE = 1
FRIEND_AWAY = 2
FRIEND_DO_NOT_DISTURB = 3
FRIEND_OFFLINE = 4

COLOR_NOT_FRIEND = "990000"
COLOR_ONLINE = "89cff0"
COLOR_AWAY = "873260"
COLOR_DO_NOT_DISTURB = "800020"
COLOR_OFFLINE = "3d2b1f"
COLOR_IN_MY_GROUP = "00cc99"

ELECTION_ACTIVE = false
ELECTION_COUNTER = 0
ELECTION_PASSED = true

ROLE_HEALER = 4
ROLE_TANK = 2
ROLE_DPS = 1
ROLE_INVALID = 0

RANDOM_NORMAL_DUNGEON = 62
SOLO_RANDOM_BATTLEGROUND = 67

JOIN_GROUP_CODE = "UHU Group Invite"

--Call the initialization
function UnDeadGroupMod.OnAddOnLoaded(event, addonName)
    if addonName == UnDeadGroupMod.name then
        UnDeadGroupMod:Initialize()
    end
end

function UnDeadGroupMod.OnIndicatorMoveStop()
    UnDeadGroupMod.SavedVariables.left = UnDeadGroupModIndicator:GetLeft()
    UnDeadGroupMod.SavedVariables.top = UnDeadGroupModIndicator:GetTop()

end

function UnDeadGroupMod.RestorePosition()
    local left = UnDeadGroupMod.SavedVariables.left
    local top = UnDeadGroupMod.SavedVariables.top
	UnDeadGroupModIndicator:ClearAnchors()
    UnDeadGroupModIndicator:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, left, top)
	
end

--Initialize the addon
function UnDeadGroupMod:Initialize()
	UnDeadGroupModIndicator:SetHidden(false)
	
    UnDeadGroupMod.SavedVariables = ZO_SavedVars:New("UnDeadGroupModSavedVariables", 2, nil, UnDeadGroupMod.defaults)
    UnDeadGroupMod.RestorePosition()
	UnDeadGroupMod.CreateSettings()
	UnDeadGroupMod.VisibilityChange()
	UnDeadGroupMod.UpdateUI()

end

--Hide UI in Menus
local gphFragment = ZO_HUDFadeSceneFragment:New(UnDeadGroupModIndicator, nil, 0)
HUD_SCENE:AddFragment(gphFragment)
HUD_UI_SCENE:AddFragment(gphFragment)


function UnDeadGroupMod.setVet()
	local isVet = IsUnitUsingVeteranDifficulty("player")
	if isVet == true then SetVeteranDifficulty(false) end
	if isVet == false then SetVeteranDifficulty(true) end
end


function UnDeadGroupMod.setRole()
	local isRole = GetSelectedLFGRole()
	if isRole == ROLE_DPS then UpdateSelectedLFGRole(ROLE_TANK) end
	if isRole == ROLE_TANK then UpdateSelectedLFGRole(ROLE_HEALER) end
	if isRole == ROLE_HEALER then UpdateSelectedLFGRole(ROLE_DPS) end
	if isRole == ROLE_INVALID then UpdateSelectedLFGRole(ROLE_DPS) end
end

function UnDeadGroupMod.UpdateUI()
	
	local isChangable = IsUnitSoloOrGroupLeader("player")
	local canChange, changeReason = CanPlayerChangeGroupDifficulty()
	local isVet = IsUnitUsingVeteranDifficulty("player")
	local isGroupVet = IsGroupUsingVeteranDifficulty()
	local amInGroup = IsUnitGrouped("player")
	
	if UnDeadGroupMod.SavedVariables.isDifficultyVisible == true then
		if isChangable == true  and canChange == true then UnDeadGroupModIndicatorButton1:SetHidden(false) end
		if isChangable == false or canChange == false then UnDeadGroupModIndicatorButton1:SetHidden(true) end
		if isVet == true and amInGroup == false then UnDeadGroupModIndicatorLabel1:SetText("Difficulty: Veteran") end
		if isVet == false and amInGroup == false then UnDeadGroupModIndicatorLabel1:SetText("Difficulty: Normal") end
		if isGroupVet == true and amInGroup == true then UnDeadGroupModIndicatorLabel1:SetText("Difficulty: Veteran") end
		if isGroupVet == false and amInGroup == true then UnDeadGroupModIndicatorLabel1:SetText("Difficulty: Normal") end
	end
	
	local isJumpable = CanJumpToHouseFromCurrentLocation()
	if isJumpable == true then UnDeadGroupModIndicatorButtonMyHouse:SetHidden(false) else UnDeadGroupModIndicatorButtonMyHouse:SetHidden(true) end
	
	if UnDeadGroupMod.SavedVariables.isReadyCheckVisible == true then
		if ELECTION_ACTIVE == true then 
			UnDeadGroupModIndicatorButtonReady:SetHidden(true)
			UnDeadGroupModIndicatorLabelReady:SetText("|cffff00Election Pending|r")
		end
		
		if ELECTION_ACTIVE == false and ELECTION_COUNTER == 0 then 
			UnDeadGroupModIndicatorButtonReady:SetHidden(false)
			UnDeadGroupModIndicatorLabelReady:SetText("Initiate Ready Check")
		end
		
		if ELECTION_ACTIVE == false and ELECTION_COUNTER > 0 then 
			ELECTION_COUNTER = ELECTION_COUNTER + 1
			if ELECTION_PASSED == true then UnDeadGroupModIndicatorLabelReady:SetText("|c00cc99Check Passed|r") end
			if ELECTION_PASSED == false then UnDeadGroupModIndicatorLabelReady:SetText("|ce32636Check Failed|r") end
			if ELECTION_COUNTER == 10 then ELECTION_COUNTER = 0 end
			UnDeadGroupModIndicatorButtonReady:SetHidden(true)
		end
	end
	
	
	
	if UnDeadGroupMod.SavedVariables.isRoleVisible == true then
		local LFGRole = GetSelectedLFGRole()
		if LFGRole == ROLE_DPS then UnDeadGroupModIndicatorLabelRole:SetText("Group Role: DPS") end
		if LFGRole == ROLE_TANK then UnDeadGroupModIndicatorLabelRole:SetText("Group Role: TANK") end
		if LFGRole == ROLE_HEALER then UnDeadGroupModIndicatorLabelRole:SetText("Group Role: HEAL") end
		
		local canUpdateRole = CanUpdateSelectedLFGRole()
		if canUpdateRole == true then UnDeadGroupModIndicatorButtonRole:SetHidden(false) else UnDeadGroupModIndicatorButtonRole:SetHidden(true) end
	end
	
	if UnDeadGroupMod.SavedVariables.selectedQ == SOLO_RANDOM_BATTLEGROUND then UnDeadGroupMod.SavedVariables.SelectedQName = "Solo Random Battleground" end
	if UnDeadGroupMod.SavedVariables.selectedQ == RANDOM_NORMAL_DUNGEON then UnDeadGroupMod.SavedVariables.SelectedQName = "Random Normal Dungeon" end
	
	
	--Get Friend Status
	local frTotal = GetNumFriends()
	local fr1Status = 0
	local fr2Status = 0
	local fr3Status = 0
	
	for index = 1, frTotal do
		local friendname, friendnote, friendstatus, friendseconds = GetFriendInfo(index)
		local hasCharacter, characterName, zoneName, classType, alliance, level, championRank, zoneId = GetFriendCharacterInfo(index)
		if friendname == UnDeadGroupMod.SavedVariables.Friend1 then
			fr1Status = friendstatus
			UnDeadGroupMod.SavedVariables.Friend1Zone = zoneName
		end
		if friendname == UnDeadGroupMod.SavedVariables.Friend2 then
			fr2Status = friendstatus
			UnDeadGroupMod.SavedVariables.Friend2Zone = zoneName
		end
		if friendname == UnDeadGroupMod.SavedVariables.Friend3 then
			fr3Status = friendstatus
			UnDeadGroupMod.SavedVariables.Friend3Zone = zoneName
		end
		if fr1Status ~= 0 and fr2Status ~= 0 and fr3Status ~= 0 then
			break
		end
	end
	
	local fr1IsFriend = IsFriend(UnDeadGroupMod.SavedVariables.Friend1)
	if fr1IsFriend == false then fr1Status = FRIEND_NOT_FRIEND end
	if isJumpable == true then UnDeadGroupModIndicatorButtonHouse1:SetHidden(false) end
	if fr1Status == FRIEND_ONLINE then UnDeadGroupModIndicatorLabel2:SetText("|c" .. COLOR_ONLINE .. UnDeadGroupMod.SavedVariables.Friend1 .. "|r") end
	if fr1Status == FRIEND_AWAY then UnDeadGroupModIndicatorLabel2:SetText("|c" .. COLOR_AWAY .. UnDeadGroupMod.SavedVariables.Friend1 .. "|r") end
	if fr1Status == FRIEND_DO_NOT_DISTURB then UnDeadGroupModIndicatorLabel2:SetText("|c" .. COLOR_DO_NOT_DISTURB .. UnDeadGroupMod.SavedVariables.Friend1 .. "|r") end
	if fr1Status == FRIEND_OFFLINE then UnDeadGroupModIndicatorLabel2:SetText("|c" .. COLOR_OFFLINE .. UnDeadGroupMod.SavedVariables.Friend1 .. "|r") end
	if fr1Status == FRIEND_NOT_FRIEND then 
		UnDeadGroupModIndicatorLabel2:SetText("Add Friends in Settings")
		UnDeadGroupModIndicatorButtonHouse1:SetHidden(true)
	else
		UnDeadGroupModIndicatorButtonHouse1:SetHidden(false)
	end
	if fr1Status == FRIEND_NOT_FRIEND or fr1Status == FRIEND_OFFLINE then 
		UnDeadGroupModIndicatorButtonJump1:SetHidden(true) 
		UnDeadGroupModIndicatorButton2:SetHidden(true)
	else 
		UnDeadGroupModIndicatorButtonJump1:SetHidden(false) 
		UnDeadGroupModIndicatorButton2:SetHidden(false)
	end
	if fr1IsFriend == false and UnDeadGroupMod.SavedVariables.Friend1 ~= "" then 
		UnDeadGroupModIndicatorLabel2:SetText("|c" .. COLOR_NOT_FRIEND .. "User not a Friend|r") 
		UnDeadGroupModIndicatorButtonHouse1:SetHidden(true)
	end
	if isJumpable == false then UnDeadGroupModIndicatorButtonHouse1:SetHidden(true) end
	
	local isInMyGroup  = IsPlayerInGroup(UnDeadGroupMod.SavedVariables.Friend1)
	if fr1Status == FRIEND_ONLINE  and isInMyGroup == true then 
		UnDeadGroupModIndicatorLabel2:SetText("|c" .. COLOR_IN_MY_GROUP .. UnDeadGroupMod.SavedVariables.Friend1 .. "|r") 
		UnDeadGroupModIndicatorButton2:SetHidden(true)
	end
	
	
	local fr2IsFriend = IsFriend(UnDeadGroupMod.SavedVariables.Friend2)
	if fr2IsFriend == false then fr2Status = FRIEND_NOT_FRIEND end
	if isJumpable == true then UnDeadGroupModIndicatorButtonHouse2:SetHidden(false) end
	if fr2Status == FRIEND_ONLINE then UnDeadGroupModIndicatorLabel3:SetText("|c" .. COLOR_ONLINE .. UnDeadGroupMod.SavedVariables.Friend2 .. "|r") end
	if fr2Status == FRIEND_AWAY then UnDeadGroupModIndicatorLabel3:SetText("|c" .. COLOR_AWAY .. UnDeadGroupMod.SavedVariables.Friend2 .. "|r") end
	if fr2Status == FRIEND_DO_NOT_DISTURB then UnDeadGroupModIndicatorLabel3:SetText("|c" .. COLOR_DO_NOT_DISTURB .. UnDeadGroupMod.SavedVariables.Friend2 .. "|r") end
	if fr2Status == FRIEND_OFFLINE then UnDeadGroupModIndicatorLabel3:SetText("|c" .. COLOR_OFFLINE .. UnDeadGroupMod.SavedVariables.Friend2 .. "|r") end
	if fr2Status == FRIEND_NOT_FRIEND then 
		UnDeadGroupModIndicatorLabel3:SetText("") 
		UnDeadGroupModIndicatorButtonHouse2:SetHidden(true)
	else
		UnDeadGroupModIndicatorButtonHouse2:SetHidden(false)
	end
	if fr2Status == FRIEND_NOT_FRIEND or fr2Status == FRIEND_OFFLINE then 
		UnDeadGroupModIndicatorButtonJump2:SetHidden(true) 
		UnDeadGroupModIndicatorButton3:SetHidden(true)
	else 
		UnDeadGroupModIndicatorButtonJump2:SetHidden(false) 
		UnDeadGroupModIndicatorButton3:SetHidden(false) 
	end
	if fr2IsFriend == false and UnDeadGroupMod.SavedVariables.Friend2 ~= "" then 
		UnDeadGroupModIndicatorLabel3:SetText("|c" .. COLOR_NOT_FRIEND .. "User not a Friend|r")
		UnDeadGroupModIndicatorButtonHouse2:SetHidden(true)
	end
	if isJumpable == false then UnDeadGroupModIndicatorButtonHouse2:SetHidden(true) end
	
	local isInMyGroup2  = IsPlayerInGroup(UnDeadGroupMod.SavedVariables.Friend2)
	if fr2Status == FRIEND_ONLINE  and isInMyGroup2 == true then 
		UnDeadGroupModIndicatorLabel3:SetText("|c" .. COLOR_IN_MY_GROUP .. UnDeadGroupMod.SavedVariables.Friend2 .. "|r") 
		UnDeadGroupModIndicatorButton3:SetHidden(true)
	end
	
	
	local fr3IsFriend = IsFriend(UnDeadGroupMod.SavedVariables.Friend3)
	if fr3IsFriend == false then fr3Status = FRIEND_NOT_FRIEND end
	if isJumpable == true then UnDeadGroupModIndicatorButtonHouse3:SetHidden(false) end
	if fr3Status == FRIEND_ONLINE then UnDeadGroupModIndicatorLabel4:SetText("|c" .. COLOR_ONLINE .. UnDeadGroupMod.SavedVariables.Friend3 .. "|r") end
	if fr3Status == FRIEND_AWAY then UnDeadGroupModIndicatorLabel4:SetText("|c" .. COLOR_AWAY .. UnDeadGroupMod.SavedVariables.Friend3 .. "|r") end
	if fr3Status == FRIEND_DO_NOT_DISTURB then UnDeadGroupModIndicatorLabel4:SetText("|c" .. COLOR_DO_NOT_DISTURB .. UnDeadGroupMod.SavedVariables.Friend3 .. "|r") end
	if fr3Status == FRIEND_OFFLINE then UnDeadGroupModIndicatorLabel4:SetText("|c" .. COLOR_OFFLINE .. UnDeadGroupMod.SavedVariables.Friend3 .. "|r") end
	if fr3Status == FRIEND_NOT_FRIEND then 
		UnDeadGroupModIndicatorLabel4:SetText("") 
		UnDeadGroupModIndicatorButtonHouse3:SetHidden(true)
	else
		UnDeadGroupModIndicatorButtonHouse3:SetHidden(false)
	end
	if fr3Status == FRIEND_NOT_FRIEND or fr3Status == FRIEND_OFFLINE then 
		UnDeadGroupModIndicatorButtonJump3:SetHidden(true) 
		UnDeadGroupModIndicatorButton4:SetHidden(true)
	else 
		UnDeadGroupModIndicatorButtonJump3:SetHidden(false) 
		UnDeadGroupModIndicatorButton4:SetHidden(false)
	end
	if fr3IsFriend == false and UnDeadGroupMod.SavedVariables.Friend3 ~= "" then 
		UnDeadGroupModIndicatorLabel4:SetText("|c" .. COLOR_NOT_FRIEND .. "User not a Friend|r")
		UnDeadGroupModIndicatorButtonHouse3:SetHidden(true)		
	end
	if isJumpable == false then UnDeadGroupModIndicatorButtonHouse3:SetHidden(true) end
	
	local isInMyGroup3  = IsPlayerInGroup(UnDeadGroupMod.SavedVariables.Friend3)
	if fr3Status == FRIEND_ONLINE  and isInMyGroup3 == true then 
		UnDeadGroupModIndicatorLabel4:SetText("|c" .. COLOR_IN_MY_GROUP .. UnDeadGroupMod.SavedVariables.Friend3 .. "|r") 
		UnDeadGroupModIndicatorButton4:SetHidden(true)
	end

end

function UnDeadGroupMod.VisibilityChange()
	--Title Visible
	if UnDeadGroupMod.SavedVariables.isTitleVisible == true then 
		UnDeadGroupModIndicatorTitle:SetHidden(false)
	else
		UnDeadGroupModIndicatorTitle:SetHidden(true)
	end
	
	--Difficulty Visible
	if UnDeadGroupMod.SavedVariables.isDifficultyVisible == true then 

		UnDeadGroupModIndicatorLabelRole:SetAnchor(3, UnDeadGroupModIndicatorLabel1, 6, 0, 0)
		UnDeadGroupModIndicatorLabel1:SetHidden(false)
		UnDeadGroupModIndicatorButton1:SetHidden(false)
		UnDeadGroupModIndicatorButtonRandom:SetHidden(false)
	else
		UnDeadGroupModIndicatorLabelRole:SetAnchor(3, UnDeadGroupModIndicatorButtonOptions, 6, 0, 0)
		UnDeadGroupModIndicatorLabel1:SetHidden(true)
		UnDeadGroupModIndicatorButton1:SetHidden(true)
		UnDeadGroupModIndicatorButtonRandom:SetHidden(true)
	end
	
	--Group Role Visible
	if UnDeadGroupMod.SavedVariables.isRoleVisible == true then 
		
		UnDeadGroupModIndicatorButtonMyHouse:SetAnchor(2, UnDeadGroupModIndicatorButtonRole, 8, 0, -1)
		UnDeadGroupModIndicatorLabel2:SetAnchor(3, UnDeadGroupModIndicatorLabelRole, 6, 0, 0)
		UnDeadGroupModIndicatorLabelRole:SetHidden(false)
		UnDeadGroupModIndicatorButtonRole:SetHidden(false)
	else
		UnDeadGroupModIndicatorButtonMyHouse:SetAnchor(2, UnDeadGroupModIndicatorTitle, 8, -50, -1)
		UnDeadGroupModIndicatorLabel2:SetAnchor(3, UnDeadGroupModIndicatorLabel1, 6, 0, 0)
		UnDeadGroupModIndicatorLabelRole:SetHidden(true)
		UnDeadGroupModIndicatorButtonRole:SetHidden(true)
	end
	
	--Ready Check Visible
	if UnDeadGroupMod.SavedVariables.isReadyCheckVisible == true then 
		UnDeadGroupModIndicatorLabelReady:SetHidden(false)
		UnDeadGroupModIndicatorButtonReady:SetHidden(false)
	else
		UnDeadGroupModIndicatorLabelReady:SetHidden(true)
		UnDeadGroupModIndicatorButtonReady:SetHidden(true)
	end

	--Ready Check Visible
	if UnDeadGroupMod.SavedVariables.didVoteNewName == false then 
		UnDeadGroupModIndicatorLabelNameContest:SetHidden(false)
		UnDeadGroupModIndicatorButtonNameContest:SetHidden(false)
	else
		UnDeadGroupModIndicatorLabelNameContest:SetHidden(true)
		UnDeadGroupModIndicatorButtonNameContest:SetHidden(true)
	end
	
	--Difficulty and Role Not Visible
	if UnDeadGroupMod.SavedVariables.isRoleVisible == false and UnDeadGroupMod.SavedVariables.isDifficultyVisible == false then
		UnDeadGroupModIndicatorLabel2:SetAnchor(3, UnDeadGroupModIndicatorButtonOptions, 6, 0, 0)
	end
	
	
end


function UnDeadGroupMod.MyHouse()
	local houseId = GetHousingPrimaryHouse()
	RequestJumpToHouse(houseId)
end

function UnDeadGroupMod.Invite1()
	local invitee1 = UnDeadGroupMod.SavedVariables.Friend1
	if invitee1 ~= nil then GroupInviteByName(invitee1) end
end

function UnDeadGroupMod.Jump1()
	local friend1 = UnDeadGroupMod.SavedVariables.Friend1
	if friend1 ~= nil then JumpToFriend(friend1) end
end

function UnDeadGroupMod.House1()
	local friend1 = UnDeadGroupMod.SavedVariables.Friend1
	if friend1 ~= nil then JumpToHouse(friend1) end
end

function UnDeadGroupMod.Invite2()
	local invitee2 = UnDeadGroupMod.SavedVariables.Friend2
	if invitee2 ~= nil then GroupInviteByName(invitee2) end
end

function UnDeadGroupMod.Jump2()
	local friend2 = UnDeadGroupMod.SavedVariables.Friend2
	if friend2 ~= nil then JumpToFriend(friend2) end
end

function UnDeadGroupMod.House2()
	local friend2 = UnDeadGroupMod.SavedVariables.Friend2
	if friend2 ~= nil then JumpToHouse(friend2) end
end

function UnDeadGroupMod.Invite3()
	local invitee3 = UnDeadGroupMod.SavedVariables.Friend3
	if invitee3 ~= nil then GroupInviteByName(invitee3) end
end

function UnDeadGroupMod.Jump3()
	local friend3 = UnDeadGroupMod.SavedVariables.Friend3
	if friend3 ~= nil then JumpToFriend(friend3) end
end

function UnDeadGroupMod.House3()
	local friend3 = UnDeadGroupMod.SavedVariables.Friend3
	if friend3 ~= nil then JumpToHouse(friend3) end
end

function UnDeadGroupMod.gotoSettings(option)
	LAM:OpenToPanel(UnDeadGroupModSettingsPanel)
end

function UnDeadGroupMod.ReadyCheck(option)
	local inGroup = IsUnitGrouped("player")
	if inGroup == true then ELECTION_ACTIVE = BeginGroupElection(2, "Hey, You Ready??", "") end
	
end

function UnDeadGroupMod.AFUpdate (eventCode, result)
	if UnDeadGroupMod.SavedVariables.willAcceptLFGCheck == true and result == 4 then
		AcceptLFGReadyCheckNotification()
	end
	
	
end

function UnDeadGroupMod.PlayerActivated()
	local numFriends = GetNumFriends()
	for index = 1, numFriends do 
		UnDeadGroupMod.FriendList[index] = GetFriendInfo(index)
	end
	--for aIndex = 1, 40 do
		--UnDeadGroupMod.SavedVariables.ActivitySetIdList[aIndex] = GetActivitySetIdByTypeAndIndex(7, aIndex)
		
		--local name, description, sortOrder = GetActivitySetInfo()
		
		
	--end

	--local rewardUIDataId, xpReward = GetActivitySetRewardData()
	--d(rewardUIDataId)
	--d(xpReward) --33682
	
end

function UnDeadGroupMod.LeaveLFG()
	if UnDeadGroupMod.SavedVariables.canLeaveLFG == true then
		GroupLeave()
	end
end


function UnDeadGroupMod.DungeonQueue()
	AddActivityFinderSetSearchEntry(UnDeadGroupMod.SavedVariables.selectedQ)
	if UnDeadGroupMod.SavedVariables.selectedQ == SOLO_RANDOM_BATTLEGROUND then d("Solo Random Battleground") end
	if UnDeadGroupMod.SavedVariables.selectedQ == RANDOM_NORMAL_DUNGEON then d("Random Normal Dungeon") end
	StartGroupFinderSearch()
end

function UnDeadGroupMod.GroupInviteReceived (eventCode, inviterCharacterName, inviterDisplayName)
	if UnDeadGroupMod.SavedVariables.willAcceptGroupInvite == true and inviterDisplayName == UnDeadGroupMod.SavedVariables.Friend1 then
		AcceptGroupInvite()
	end
	if UnDeadGroupMod.SavedVariables.willAcceptGroupInvite == true and inviterDisplayName == UnDeadGroupMod.SavedVariables.Friend2 then
		AcceptGroupInvite()
	end
	if UnDeadGroupMod.SavedVariables.willAcceptGroupInvite == true and inviterDisplayName == UnDeadGroupMod.SavedVariables.Friend3 then
		AcceptGroupInvite()
	end
end

local org = PLAYER_TO_PLAYER.AddPromptToIncomingQueue
function PLAYER_TO_PLAYER.AddPromptToIncomingQueue(self, interactType, characterName, displayName, targetLabel,
                                                   acceptCallback, declineCallback, deferDecisionCallback)

    -- Do not call this stuff if you did not recently join a group
    if interactType == 19 and groupMemberJoinedFlag and UnDeadGroupMod.SavedVariables.willNotAcceptTravelToLeader then
        groupMemberJoinedFlag = false
        return {}
    else
        return org(self, interactType, characterName, displayName, targetLabel, acceptCallback, declineCallback,
                   deferDecisionCallback)
    end
end

function UnDeadGroupMod.OnGroupMemberJoined(eventCode, memberCharacterName, memberDisplayName, isLocalPlayer)

    -- Only check for yourself as other group members joing won't show the port to group leader popup
    if isLocalPlayer and UnDeadGroupMod.SavedVariables.willNotAcceptTravelToLeader then
        groupMemberJoinedFlag = true
    end
end

function UnDeadGroupMod.ElectionResult (eventCode, result, descriptor)
	--Positive
	if result == 4 then 
	ELECTION_COUNTER = 1 
	ELECTION_PASSED = true
	end
	--Negative
	if result == 5 then 
	ELECTION_COUNTER = 1 
	ELECTION_PASSED = false
	end
	
	ELECTION_ACTIVE = false
	
end

function UnDeadGroupMod.ChatMessageEvent (eventCode, channelType, fromName, text, isCustomerService, fromDisplayName)
	if text == JOIN_GROUP_CODE and channelType == 2 then
		GroupInviteByName(fromName)
	end
end

function UnDeadGroupMod.SendJoinMessage()
	local msgToSend = string.format("/w %s %s",UnDeadGroupMod.FriendToJoin ,JOIN_GROUP_CODE)
	CHAT_SYSTEM:StartTextEntry(msgToSend)
	ZO_ChatWindowTextEntry:SetAlpha(1)
	ZO_ChatWindowTextEntryEditBox:SelectAll()
	ZO_ChatWindowTextEntryEditBox:TakeFocus()
end

function UnDeadGroupMod.CreateSettings()
	local panelName = "UnDeadGroupModSettingsPanel"

	local panelData = {
	   type = "panel",
		name = "UnDead's Group Utilities",
		displayName = "UnDead's Group Utilities",
		author = "UnDead0rbit",
		website = "https://www.esoui.com/downloads/info2730-UnDeadsGroupUtilities.html",
        feedback = "https://www.esoui.com/portal.php?uid=60193&a=listbugs",
		registerForRefresh = true,
		registerForDefaults = true,
	}
	local panel = LAM:RegisterAddonPanel(panelName, panelData)
	
	local optionsData = {}
		optionsData[#optionsData + 1] = {
			type = "header",
			name = "Name This Mod!",
		}
		optionsData[#optionsData + 1] = {
			type = "description",
			text = "This mod has had a difficult time getting out there from what I can tell as poor naming.  I feel like this is my best mod, yet the other lesser mods have more downloads from only what I can tell from better names.  Help ReName This Mod, and for the Selected Suggestion, I will send 100k of Gold! and give you credit here in the settings.",
		}
		optionsData[#optionsData + 1] = {
			type = "editbox",
			name = "Type Name to Suggest. Winner Gets 100k Gold!",
			sort = "name-up",
			isMultiline = true,
			isExtraWide = true,
			width = "full",
			requiresReload = false,
			getFunc = function() return nil end,
			setFunc = function(value) UnDeadGroupMod.MailBody = value end
		}
		optionsData[#optionsData + 1] = {
            type = "button",
            name = "Send Suggestion",
			width = "full",
            func = function()
				SCENE_MANAGER:ShowBaseScene()
				RequestOpenMailbox()
                SendMail("@UnDead0rbit", "Group Utilities Name", UnDeadGroupMod.MailBody)
				d("Mail Sent to @UnDead0rbit")
				UnDeadGroupMod.SavedVariables.didVoteNewName = true
            end,
        }
		optionsData[#optionsData + 1] = {
			type = "header",
			name = "Join a Friend's Group",
		}
		optionsData[#optionsData + 1] = {
			type = "description",
			text = "Step 1: Select a Friend.\nStep 2: Press Enter to Send the Chat Message Generated.",
		}
		optionsData[#optionsData + 1] = {
			type = "dropdown",
			name = "Select Friend to Join",
			choices = UnDeadGroupMod.FriendList,
			sort = "name-up",
			scrollable = true,
			default = false,
			width = "half",
			requiresReload = false,
			getFunc = function() return nil end,
			setFunc = function(value) 
			SCENE_MANAGER:ShowBaseScene()
			UnDeadGroupMod.FriendToJoin = value 
			UnDeadGroupMod.SendJoinMessage()
			end
		}
		optionsData[#optionsData + 1] = {
			type = "description",
			text = "Conditions: Selected Friend Must Have this Mod Installed! \nAlso, Friend must be solo or group leader, online, and able to be joined.",
		}
		optionsData[#optionsData + 1] = {
            type = "button",
            name = "Close Settings",
			width = "full",
            func = function()
                SCENE_MANAGER:ShowBaseScene()
            end,
        }
		optionsData[#optionsData + 1] = {
			type = "header",
			name = "Favorite Friends",
		}
		optionsData[#optionsData + 1] = {
			type = "description",
			text = "Here you can select up to 3 friends to have on the UI for status, quick invites, traveling to player and home. \n(more slots will be avaliable soon).",
		}
		optionsData[#optionsData + 1] = {
			type = "description",
			width = "half",
			text = "Status Colors\n|c89cff0Player is ONLINE|r\n|c873260Player is AWAY|r\n|c800020Player is DO NOT DISTURB|r\n|c3d2b1fPlayer is OFFLINE|r",
		}
		optionsData[#optionsData + 1] = {
			type = "dropdown",
			name = "Friend Slot 1",
			choices = UnDeadGroupMod.FriendList,
			sort = "name-up",
			scrollable = true,
			default = false,
			width = "half",
			requiresReload = false,
			getFunc = function() return UnDeadGroupMod.SavedVariables.Friend1 end,
			setFunc = function(value) UnDeadGroupMod.SavedVariables.Friend1 = value end
		}
		optionsData[#optionsData + 1] = {
			type = "dropdown",
			name = "Friend Slot 2",
			choices = UnDeadGroupMod.FriendList,
			sort = "name-up",
			scrollable = true,
			default = false,
			width = "half",
			requiresReload = false,
			getFunc = function() return UnDeadGroupMod.SavedVariables.Friend2 end,
			setFunc = function(value) UnDeadGroupMod.SavedVariables.Friend2 = value end
		}
		optionsData[#optionsData + 1] = {
			type = "dropdown",
			name = "Friend Slot 3",
			choices = UnDeadGroupMod.FriendList,
			sort = "name-up",
			scrollable = true,
			default = false,
			width = "half",
			requiresReload = false,
			getFunc = function() return UnDeadGroupMod.SavedVariables.Friend3 end,
			setFunc = function(value) UnDeadGroupMod.SavedVariables.Friend3 = value end
		}
		
		--[[dropdownData = {
			type = "dropdown",
			name = "My Dropdown", -- or string id or function returning a string
			choices = {"table", "of", "choices"},
			choicesValues = {"foo", 2, "three"}, -- if specified, these values will get passed to setFunc instead (optional)
			getFunc = function() return db.var end,
			setFunc = function(var) db.var = var doStuff() end,
			tooltip = "Dropdown's tooltip text.", -- or string id or function returning a string (optional)
			choicesTooltips = {"tooltip 1", "tooltip 2", "tooltip 3"}, -- or array of string ids or array of functions returning a string (optional)
			sort = "name-up", -- or "name-down", "numeric-up", "numeric-down", "value-up", "value-down", "numericvalue-up", "numericvalue-down" (optional) - if not provided, list will not be sorted
			width = "full", -- or "half" (optional)
			scrollable = true, -- boolean or number, if set the dropdown will feature a scroll bar if there are a large amount of choices and limit the visible lines to the specified number or 10 if true is used (optional)
			disabled = function() return db.someBooleanSetting end, -- or boolean (optional)
			warning = "May cause permanent awesomeness.", -- or string id or function returning a string (optional)
			requiresReload = false, -- boolean, if set to true, the warning text will contain a notice that changes are only applied after an UI reload and any change to the value will make the "Apply Settings" button appear on the panel which will reload the UI when pressed (optional)
			default = defaults.var, -- default value or function that returns the default value (optional)
			helpUrl = "https://www.esoui.com/portal.php?id=218&a=faq", -- a string URL or a function that returns the string URL (optional)
			reference = "MyAddonDropdown" -- unique global reference to control (optional)
		} ]]
		
		optionsData[#optionsData + 1] = {
			type = "description",
			text = "If you recently added a friend, they may not appear until you travel or reloadui.",
		}
		optionsData[#optionsData + 1] = {
			type = "header",
			name = "Auto Acceptors",
		}
		optionsData[#optionsData + 1] = {
			type = "checkbox",
			name = "Auto LFG Ready Check",
			default = false,
			width = "full",
			getFunc = function() return UnDeadGroupMod.SavedVariables.willAcceptLFGCheck end,
			setFunc = function(value) UnDeadGroupMod.SavedVariables.willAcceptLFGCheck = value end
		}
		optionsData[#optionsData + 1] = {
			type = "checkbox",
			name = "Auto Leave LFG Group After Activity Completes",
			default = false,
			width = "full",
			warning = "Not Recommended, May BREAK Your Ability to Group, Until a Server Reset...  happened to me and a friend... not 100 positive it was because of this but pretty sure it was due to it triggering so fast after the activity ended. any ways use at your own risk....",
			getFunc = function() return UnDeadGroupMod.SavedVariables.canLeaveLFG end,
			setFunc = function(value) UnDeadGroupMod.SavedVariables.canLeaveLFG = value end
		}
		optionsData[#optionsData + 1] = {
			type = "checkbox",
			name = "Auto Accept Group Invite from Favorites",
			default = false,
			width = "full",
			tooltip = "Doesnt Accept the Fast Travel to Leader if in another Zone, only the Initial Invite.",
			getFunc = function() return UnDeadGroupMod.SavedVariables.willAcceptGroupInvite end,
			setFunc = function(value) UnDeadGroupMod.SavedVariables.willAcceptGroupInvite = value end
		}
		optionsData[#optionsData + 1] = {
			type = "checkbox",
			name = "Disable Travel to Leader Dialog",
			default = false,
			width = "full",
			tooltip = "If true, when accepting a group invite, it will not prompt you to travel to leader.",
			getFunc = function() return UnDeadGroupMod.SavedVariables.willNotAcceptTravelToLeader end,
			setFunc = function(value) UnDeadGroupMod.SavedVariables.willNotAcceptTravelToLeader = value end
		}
		optionsData[#optionsData + 1] = {
			type = "dropdown",
			name = "Auto Queue Button Selection",
			choices = {"Random Normal Dungeon","Solo Random Battleground"},
			choicesValues = {RANDOM_NORMAL_DUNGEON, SOLO_RANDOM_BATTLEGROUND}, -- if specified, these values will get passed to setFunc instead (optional)
			sort = "name-up",
			scrollable = true,
			default = "Random Normal Dungeon",
			width = "full",
			requiresReload = false,
			getFunc = function() return UnDeadGroupMod.SavedVariables.selectedQ end,
			setFunc = function(value) UnDeadGroupMod.SavedVariables.selectedQ = value end
		}
		optionsData[#optionsData + 1] = {
			type = "header",
			name = "Display Settings",
		}
		optionsData[#optionsData + 1] = {
			type = "description",
			text = "Change the UI elements of the mod.",
		}
		optionsData[#optionsData + 1] = {
			type = "checkbox",
			name = "Show Difficulty",
			default = true,
			width = "half",
			tooltip = "if false, hides the Difficulty selector",
			getFunc = function() return UnDeadGroupMod.SavedVariables.isDifficultyVisible end,
			setFunc = function(value) 
			UnDeadGroupMod.SavedVariables.isDifficultyVisible = value 
			UnDeadGroupMod.VisibilityChange()
			end
		}
		optionsData[#optionsData + 1] = {
			type = "checkbox",
			name = "Show Group Role",
			default = true,
			width = "half",
			tooltip = "if false, hides the Group Role selector",
			getFunc = function() return UnDeadGroupMod.SavedVariables.isRoleVisible end,
			setFunc = function(value) 
			UnDeadGroupMod.SavedVariables.isRoleVisible = value 
			UnDeadGroupMod.VisibilityChange()
			end
		}
		optionsData[#optionsData + 1] = {
			type = "checkbox",
			name = "Show Ready Check",
			default = true,
			width = "half",
			tooltip = "if false, hides the Election selector",
			getFunc = function() return UnDeadGroupMod.SavedVariables.isReadyCheckVisible end,
			setFunc = function(value) 
			UnDeadGroupMod.SavedVariables.isReadyCheckVisible = value 
			UnDeadGroupMod.VisibilityChange()
			end
		}
		optionsData[#optionsData + 1] = {
			type = "checkbox",
			name = "Show Mod Title",
			default = true,
			width = "half",
			tooltip = "if false, hides the Title selector",
			getFunc = function() return UnDeadGroupMod.SavedVariables.isTitleVisible end,
			setFunc = function(value) 
			UnDeadGroupMod.SavedVariables.isTitleVisible = value 
			UnDeadGroupMod.VisibilityChange()
			end
		}
		optionsData[#optionsData + 1] = {
			type = "header",
			name = "Contact Mod Developer",
		}
		optionsData[#optionsData + 1] = {
			type = "description",
			text = "Feel free to contact me with any bugs, comments, or anything else.",
		}
		optionsData[#optionsData + 1] = {
            type = "button",
            name = "Send Friend Request",
			width = "full",
            func = function()
                RequestFriend("@UnDead0rbit", "UnDead Utilities Mod Request")
            end,
        }
		optionsData[#optionsData + 1] = {
            type = "divider",
			width = "full", -- or "half" (optional)
			height = 8, -- (optional)
			alpha = 0.25, -- (optional)
        }
		optionsData[#optionsData + 1] = {
			type = "dropdown",
			name = "Select Mail Topic",
			choices = {"Bug Report","Comment","Give Idea","Other Reason"},
			choicesValues = {"Re: I Have a Bug in UnDead Utilities Mod","Re: Comment on UnDead Utilities Mod","Re: I have an idea for UnDead Utilities Mod","Re: I have something to tell you."}, -- if specified, these values will get passed to setFunc instead (optional)
			sort = "name-up",
			scrollable = true,
			default = "Bug Report",
			width = "full",
			requiresReload = false,
			getFunc = function() return UnDeadGroupMod.MailTopic end,
			setFunc = function(value) UnDeadGroupMod.MailTopic = value end
		}
		optionsData[#optionsData + 1] = {
			type = "editbox",
			name = "Type Message To Send",
			sort = "name-up",
			isMultiline = true,
			isExtraWide = true,
			width = "full",
			requiresReload = false,
			getFunc = function() return nil end,
			setFunc = function(value) UnDeadGroupMod.MailBody = value end
		}
		optionsData[#optionsData + 1] = {
            type = "button",
            name = "Send Mail",
			width = "full",
            func = function()
				SCENE_MANAGER:ShowBaseScene()
				RequestOpenMailbox()
                SendMail("@UnDead0rbit", UnDeadGroupMod.MailTopic, UnDeadGroupMod.MailBody)
				d("Mail Sent to @UnDead0rbit")
            end,
        }
		optionsData[#optionsData + 1] = {
			type = "header",
			name = "Additional Info",
		}
		optionsData[#optionsData + 1] = {
			type = "description",
			text = "The Change Difficulty Button does change the difficulty setting, yet the icon in your group menu will not update to show that without reloading the ui.  I had it force reloadui at first, but decided that was more annoying than it not showing.\n\n Nevertheless, if the difficulty says Vet, then you are on vet just the icon in your game menu may not be refreshed.",
		}
		
	LAM:RegisterOptionControls(panelName, optionsData)
end


--Events
EVENT_MANAGER:RegisterForEvent(UnDeadGroupMod.name, EVENT_ADD_ON_LOADED, UnDeadGroupMod.OnAddOnLoaded)
EVENT_MANAGER:RegisterForEvent(UnDeadGroupMod.name, EVENT_PLAYER_ACTIVATED, UnDeadGroupMod.PlayerActivated)
EVENT_MANAGER:RegisterForUpdate(UnDeadGroupMod.name, UnDeadGroupMod.updateTimeInSeconds, UnDeadGroupMod.UpdateUI)
EVENT_MANAGER:RegisterForEvent(UnDeadGroupMod.name, EVENT_ACTIVITY_FINDER_STATUS_UPDATE, UnDeadGroupMod.AFUpdate)
EVENT_MANAGER:RegisterForEvent(UnDeadGroupMod.name, EVENT_GROUP_ELECTION_RESULT, UnDeadGroupMod.ElectionResult)
EVENT_MANAGER:RegisterForEvent(UnDeadGroupMod.name, EVENT_GROUP_INVITE_RECEIVED, UnDeadGroupMod.GroupInviteReceived)
--EVENT_MANAGER:RegisterForEvent(UnDeadGroupMod.name, EVENT_GROUPING_TOOLS_LFG_JOINED, UnDeadGroupMod.LFGJoined)
EVENT_MANAGER:RegisterForEvent(UnDeadGroupMod.name, EVENT_GROUP_MEMBER_JOINED, UnDeadGroupMod.OnGroupMemberJoined)
EVENT_MANAGER:RegisterForEvent(UnDeadGroupMod.name, EVENT_CHAT_MESSAGE_CHANNEL, UnDeadGroupMod.ChatMessageEvent)
EVENT_MANAGER:RegisterForEvent(UnDeadGroupMod.name, EVENT_ACTIVITY_FINDER_ACTIVITY_COMPLETE, UnDeadGroupMod.LeaveLFG)
